// Package v1 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.12.4 DO NOT EDIT.
package v1

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
)

// Mission defines model for Mission.
type Mission struct {
	Description *string `json:"description,omitempty"`
	Fields      Fields  `json:"fields"`
	Id          int     `json:"id"`
	Name        string  `json:"name"`
}

// Fields defines model for fields.
type Fields = string

// GetMissionsParams defines parameters for GetMissions.
type GetMissionsParams struct {
	Limit  *int `form:"limit,omitempty" json:"limit,omitempty"`
	Offset *int `form:"offset,omitempty" json:"offset,omitempty"`
}

// CreateMissionJSONRequestBody defines body for CreateMission for application/json ContentType.
type CreateMissionJSONRequestBody = Mission

// UpdateMissionJSONRequestBody defines body for UpdateMission for application/json ContentType.
type UpdateMissionJSONRequestBody = Mission

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// GetMissions request
	GetMissions(ctx context.Context, params *GetMissionsParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateMission request with any body
	CreateMissionWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateMission(ctx context.Context, body CreateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// DeleteMission request
	DeleteMission(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetMission request
	GetMission(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// UpdateMission request with any body
	UpdateMissionWithBody(ctx context.Context, id string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	UpdateMission(ctx context.Context, id string, body UpdateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetGrafanaTemplate request
	GetGrafanaTemplate(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) GetMissions(ctx context.Context, params *GetMissionsParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetMissionsRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateMissionWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateMissionRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateMission(ctx context.Context, body CreateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateMissionRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) DeleteMission(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewDeleteMissionRequest(c.Server, id)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetMission(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetMissionRequest(c.Server, id)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) UpdateMissionWithBody(ctx context.Context, id string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewUpdateMissionRequestWithBody(c.Server, id, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) UpdateMission(ctx context.Context, id string, body UpdateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewUpdateMissionRequest(c.Server, id, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetGrafanaTemplate(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetGrafanaTemplateRequest(c.Server, id)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewGetMissionsRequest generates requests for GetMissions
func NewGetMissionsRequest(server string, params *GetMissionsParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	queryValues := queryURL.Query()

	if params.Limit != nil {

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "limit", runtime.ParamLocationQuery, *params.Limit); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

	}

	if params.Offset != nil {

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "offset", runtime.ParamLocationQuery, *params.Offset); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

	}

	queryURL.RawQuery = queryValues.Encode()

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateMissionRequest calls the generic CreateMission builder with application/json body
func NewCreateMissionRequest(server string, body CreateMissionJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateMissionRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateMissionRequestWithBody generates requests for CreateMission with any type of body
func NewCreateMissionRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewDeleteMissionRequest generates requests for DeleteMission
func NewDeleteMissionRequest(server string, id string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "id", runtime.ParamLocationPath, id)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetMissionRequest generates requests for GetMission
func NewGetMissionRequest(server string, id string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "id", runtime.ParamLocationPath, id)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewUpdateMissionRequest calls the generic UpdateMission builder with application/json body
func NewUpdateMissionRequest(server string, id string, body UpdateMissionJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewUpdateMissionRequestWithBody(server, id, "application/json", bodyReader)
}

// NewUpdateMissionRequestWithBody generates requests for UpdateMission with any type of body
func NewUpdateMissionRequestWithBody(server string, id string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "id", runtime.ParamLocationPath, id)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("PUT", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewGetGrafanaTemplateRequest generates requests for GetGrafanaTemplate
func NewGetGrafanaTemplateRequest(server string, id string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "id", runtime.ParamLocationPath, id)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/missions/%s/grafana", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// GetMissions request
	GetMissionsWithResponse(ctx context.Context, params *GetMissionsParams, reqEditors ...RequestEditorFn) (*GetMissionsResponse, error)

	// CreateMission request with any body
	CreateMissionWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateMissionResponse, error)

	CreateMissionWithResponse(ctx context.Context, body CreateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateMissionResponse, error)

	// DeleteMission request
	DeleteMissionWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*DeleteMissionResponse, error)

	// GetMission request
	GetMissionWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*GetMissionResponse, error)

	// UpdateMission request with any body
	UpdateMissionWithBodyWithResponse(ctx context.Context, id string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*UpdateMissionResponse, error)

	UpdateMissionWithResponse(ctx context.Context, id string, body UpdateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*UpdateMissionResponse, error)

	// GetGrafanaTemplate request
	GetGrafanaTemplateWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*GetGrafanaTemplateResponse, error)
}

type GetMissionsResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *[]Mission
	JSON500      *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r GetMissionsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetMissionsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateMissionResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *Mission
	JSON400      *struct {
		Message string `json:"message"`
	}
	JSON500 *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r CreateMissionResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateMissionResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type DeleteMissionResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON404      *struct {
		Message string `json:"message"`
	}
	JSON500 *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r DeleteMissionResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r DeleteMissionResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetMissionResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *Mission
	JSON404      *struct {
		Message string `json:"message"`
	}
	JSON500 *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r GetMissionResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetMissionResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type UpdateMissionResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *Mission
	JSON400      *struct {
		Message string `json:"message"`
	}
	JSON404 *struct {
		Message string `json:"message"`
	}
	JSON500 *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r UpdateMissionResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r UpdateMissionResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetGrafanaTemplateResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON404      *struct {
		Message string `json:"message"`
	}
	JSON500 *struct {
		Code   int    `json:"code"`
		Reason string `json:"reason"`
	}
}

// Status returns HTTPResponse.Status
func (r GetGrafanaTemplateResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetGrafanaTemplateResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// GetMissionsWithResponse request returning *GetMissionsResponse
func (c *ClientWithResponses) GetMissionsWithResponse(ctx context.Context, params *GetMissionsParams, reqEditors ...RequestEditorFn) (*GetMissionsResponse, error) {
	rsp, err := c.GetMissions(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetMissionsResponse(rsp)
}

// CreateMissionWithBodyWithResponse request with arbitrary body returning *CreateMissionResponse
func (c *ClientWithResponses) CreateMissionWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateMissionResponse, error) {
	rsp, err := c.CreateMissionWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateMissionResponse(rsp)
}

func (c *ClientWithResponses) CreateMissionWithResponse(ctx context.Context, body CreateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateMissionResponse, error) {
	rsp, err := c.CreateMission(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateMissionResponse(rsp)
}

// DeleteMissionWithResponse request returning *DeleteMissionResponse
func (c *ClientWithResponses) DeleteMissionWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*DeleteMissionResponse, error) {
	rsp, err := c.DeleteMission(ctx, id, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseDeleteMissionResponse(rsp)
}

// GetMissionWithResponse request returning *GetMissionResponse
func (c *ClientWithResponses) GetMissionWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*GetMissionResponse, error) {
	rsp, err := c.GetMission(ctx, id, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetMissionResponse(rsp)
}

// UpdateMissionWithBodyWithResponse request with arbitrary body returning *UpdateMissionResponse
func (c *ClientWithResponses) UpdateMissionWithBodyWithResponse(ctx context.Context, id string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*UpdateMissionResponse, error) {
	rsp, err := c.UpdateMissionWithBody(ctx, id, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseUpdateMissionResponse(rsp)
}

func (c *ClientWithResponses) UpdateMissionWithResponse(ctx context.Context, id string, body UpdateMissionJSONRequestBody, reqEditors ...RequestEditorFn) (*UpdateMissionResponse, error) {
	rsp, err := c.UpdateMission(ctx, id, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseUpdateMissionResponse(rsp)
}

// GetGrafanaTemplateWithResponse request returning *GetGrafanaTemplateResponse
func (c *ClientWithResponses) GetGrafanaTemplateWithResponse(ctx context.Context, id string, reqEditors ...RequestEditorFn) (*GetGrafanaTemplateResponse, error) {
	rsp, err := c.GetGrafanaTemplate(ctx, id, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetGrafanaTemplateResponse(rsp)
}

// ParseGetMissionsResponse parses an HTTP response from a GetMissionsWithResponse call
func ParseGetMissionsResponse(rsp *http.Response) (*GetMissionsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetMissionsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest []Mission
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseCreateMissionResponse parses an HTTP response from a CreateMissionWithResponse call
func ParseCreateMissionResponse(rsp *http.Response) (*CreateMissionResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateMissionResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest Mission
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseDeleteMissionResponse parses an HTTP response from a DeleteMissionWithResponse call
func ParseDeleteMissionResponse(rsp *http.Response) (*DeleteMissionResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &DeleteMissionResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseGetMissionResponse parses an HTTP response from a GetMissionWithResponse call
func ParseGetMissionResponse(rsp *http.Response) (*GetMissionResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetMissionResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest Mission
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseUpdateMissionResponse parses an HTTP response from a UpdateMissionWithResponse call
func ParseUpdateMissionResponse(rsp *http.Response) (*UpdateMissionResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &UpdateMissionResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest Mission
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseGetGrafanaTemplateResponse parses an HTTP response from a GetGrafanaTemplateWithResponse call
func ParseGetGrafanaTemplateResponse(rsp *http.Response) (*GetGrafanaTemplateResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetGrafanaTemplateResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest struct {
			Message string `json:"message"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest struct {
			Code   int    `json:"code"`
			Reason string `json:"reason"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Get all missions
	// (GET /v1/missions)
	GetMissions(w http.ResponseWriter, r *http.Request, params GetMissionsParams)
	// Create a new mission
	// (POST /v1/missions)
	CreateMission(w http.ResponseWriter, r *http.Request)
	// Delete a mission by id
	// (DELETE /v1/missions/{id})
	DeleteMission(w http.ResponseWriter, r *http.Request, id string)
	// Get a mission by id
	// (GET /v1/missions/{id})
	GetMission(w http.ResponseWriter, r *http.Request, id string)
	// Update a mission by id
	// (PUT /v1/missions/{id})
	UpdateMission(w http.ResponseWriter, r *http.Request, id string)
	// Get a grafana template for a mission by id
	// (GET /v1/missions/{id}/grafana)
	GetGrafanaTemplate(w http.ResponseWriter, r *http.Request, id string)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// GetMissions operation middleware
func (siw *ServerInterfaceWrapper) GetMissions(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetMissionsParams

	// ------------- Optional query parameter "limit" -------------

	err = runtime.BindQueryParameter("form", true, false, "limit", r.URL.Query(), &params.Limit)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "limit", Err: err})
		return
	}

	// ------------- Optional query parameter "offset" -------------

	err = runtime.BindQueryParameter("form", true, false, "offset", r.URL.Query(), &params.Offset)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "offset", Err: err})
		return
	}

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetMissions(w, r, params)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateMission operation middleware
func (siw *ServerInterfaceWrapper) CreateMission(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateMission(w, r)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// DeleteMission operation middleware
func (siw *ServerInterfaceWrapper) DeleteMission(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, chi.URLParam(r, "id"), &id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.DeleteMission(w, r, id)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetMission operation middleware
func (siw *ServerInterfaceWrapper) GetMission(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, chi.URLParam(r, "id"), &id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetMission(w, r, id)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// UpdateMission operation middleware
func (siw *ServerInterfaceWrapper) UpdateMission(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, chi.URLParam(r, "id"), &id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.UpdateMission(w, r, id)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetGrafanaTemplate operation middleware
func (siw *ServerInterfaceWrapper) GetGrafanaTemplate(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, chi.URLParam(r, "id"), &id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	var handler http.Handler = http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetGrafanaTemplate(w, r, id)
	})

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshallingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshallingParamError) Error() string {
	return fmt.Sprintf("Error unmarshalling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshallingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/missions", wrapper.GetMissions)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/v1/missions", wrapper.CreateMission)
	})
	r.Group(func(r chi.Router) {
		r.Delete(options.BaseURL+"/v1/missions/{id}", wrapper.DeleteMission)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/missions/{id}", wrapper.GetMission)
	})
	r.Group(func(r chi.Router) {
		r.Put(options.BaseURL+"/v1/missions/{id}", wrapper.UpdateMission)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/missions/{id}/grafana", wrapper.GetGrafanaTemplate)
	})

	return r
}

type GetMissionsRequestObject struct {
	Params GetMissionsParams
}

type GetMissionsResponseObject interface {
	VisitGetMissionsResponse(w http.ResponseWriter) error
}

type GetMissions200JSONResponse []Mission

func (response GetMissions200JSONResponse) VisitGetMissionsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetMissions500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response GetMissions500JSONResponse) VisitGetMissionsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateMissionRequestObject struct {
	Body *CreateMissionJSONRequestBody
}

type CreateMissionResponseObject interface {
	VisitCreateMissionResponse(w http.ResponseWriter) error
}

type CreateMission201JSONResponse Mission

func (response CreateMission201JSONResponse) VisitCreateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(201)

	return json.NewEncoder(w).Encode(response)
}

type CreateMission400JSONResponse struct {
	Message string `json:"message"`
}

func (response CreateMission400JSONResponse) VisitCreateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateMission500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response CreateMission500JSONResponse) VisitCreateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type DeleteMissionRequestObject struct {
	Id string `json:"id"`
}

type DeleteMissionResponseObject interface {
	VisitDeleteMissionResponse(w http.ResponseWriter) error
}

type DeleteMission204Response struct {
}

func (response DeleteMission204Response) VisitDeleteMissionResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type DeleteMission404JSONResponse struct {
	Message string `json:"message"`
}

func (response DeleteMission404JSONResponse) VisitDeleteMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type DeleteMission500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response DeleteMission500JSONResponse) VisitDeleteMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type GetMissionRequestObject struct {
	Id string `json:"id"`
}

type GetMissionResponseObject interface {
	VisitGetMissionResponse(w http.ResponseWriter) error
}

type GetMission200JSONResponse Mission

func (response GetMission200JSONResponse) VisitGetMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetMission404JSONResponse struct {
	Message string `json:"message"`
}

func (response GetMission404JSONResponse) VisitGetMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type GetMission500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response GetMission500JSONResponse) VisitGetMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type UpdateMissionRequestObject struct {
	Id   string `json:"id"`
	Body *UpdateMissionJSONRequestBody
}

type UpdateMissionResponseObject interface {
	VisitUpdateMissionResponse(w http.ResponseWriter) error
}

type UpdateMission200JSONResponse Mission

func (response UpdateMission200JSONResponse) VisitUpdateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type UpdateMission400JSONResponse struct {
	Message string `json:"message"`
}

func (response UpdateMission400JSONResponse) VisitUpdateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type UpdateMission404JSONResponse struct {
	Message string `json:"message"`
}

func (response UpdateMission404JSONResponse) VisitUpdateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type UpdateMission500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response UpdateMission500JSONResponse) VisitUpdateMissionResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type GetGrafanaTemplateRequestObject struct {
	Id string `json:"id"`
}

type GetGrafanaTemplateResponseObject interface {
	VisitGetGrafanaTemplateResponse(w http.ResponseWriter) error
}

type GetGrafanaTemplate200TextResponse string

func (response GetGrafanaTemplate200TextResponse) VisitGetGrafanaTemplateResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "text/plain")
	w.WriteHeader(200)

	_, err := w.Write([]byte(response))
	return err
}

type GetGrafanaTemplate404JSONResponse struct {
	Message string `json:"message"`
}

func (response GetGrafanaTemplate404JSONResponse) VisitGetGrafanaTemplateResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type GetGrafanaTemplate500JSONResponse struct {
	Code   int    `json:"code"`
	Reason string `json:"reason"`
}

func (response GetGrafanaTemplate500JSONResponse) VisitGetGrafanaTemplateResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Get all missions
	// (GET /v1/missions)
	GetMissions(ctx context.Context, request GetMissionsRequestObject) (GetMissionsResponseObject, error)
	// Create a new mission
	// (POST /v1/missions)
	CreateMission(ctx context.Context, request CreateMissionRequestObject) (CreateMissionResponseObject, error)
	// Delete a mission by id
	// (DELETE /v1/missions/{id})
	DeleteMission(ctx context.Context, request DeleteMissionRequestObject) (DeleteMissionResponseObject, error)
	// Get a mission by id
	// (GET /v1/missions/{id})
	GetMission(ctx context.Context, request GetMissionRequestObject) (GetMissionResponseObject, error)
	// Update a mission by id
	// (PUT /v1/missions/{id})
	UpdateMission(ctx context.Context, request UpdateMissionRequestObject) (UpdateMissionResponseObject, error)
	// Get a grafana template for a mission by id
	// (GET /v1/missions/{id}/grafana)
	GetGrafanaTemplate(ctx context.Context, request GetGrafanaTemplateRequestObject) (GetGrafanaTemplateResponseObject, error)
}

type StrictHandlerFunc func(ctx context.Context, w http.ResponseWriter, r *http.Request, args interface{}) (interface{}, error)

type StrictMiddlewareFunc func(f StrictHandlerFunc, operationID string) StrictHandlerFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// GetMissions operation middleware
func (sh *strictHandler) GetMissions(w http.ResponseWriter, r *http.Request, params GetMissionsParams) {
	var request GetMissionsRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetMissions(ctx, request.(GetMissionsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetMissions")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetMissionsResponseObject); ok {
		if err := validResponse.VisitGetMissionsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// CreateMission operation middleware
func (sh *strictHandler) CreateMission(w http.ResponseWriter, r *http.Request) {
	var request CreateMissionRequestObject

	var body CreateMissionJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateMission(ctx, request.(CreateMissionRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateMission")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateMissionResponseObject); ok {
		if err := validResponse.VisitCreateMissionResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// DeleteMission operation middleware
func (sh *strictHandler) DeleteMission(w http.ResponseWriter, r *http.Request, id string) {
	var request DeleteMissionRequestObject

	request.Id = id

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.DeleteMission(ctx, request.(DeleteMissionRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "DeleteMission")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(DeleteMissionResponseObject); ok {
		if err := validResponse.VisitDeleteMissionResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// GetMission operation middleware
func (sh *strictHandler) GetMission(w http.ResponseWriter, r *http.Request, id string) {
	var request GetMissionRequestObject

	request.Id = id

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetMission(ctx, request.(GetMissionRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetMission")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetMissionResponseObject); ok {
		if err := validResponse.VisitGetMissionResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// UpdateMission operation middleware
func (sh *strictHandler) UpdateMission(w http.ResponseWriter, r *http.Request, id string) {
	var request UpdateMissionRequestObject

	request.Id = id

	var body UpdateMissionJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.UpdateMission(ctx, request.(UpdateMissionRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "UpdateMission")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(UpdateMissionResponseObject); ok {
		if err := validResponse.VisitUpdateMissionResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// GetGrafanaTemplate operation middleware
func (sh *strictHandler) GetGrafanaTemplate(w http.ResponseWriter, r *http.Request, id string) {
	var request GetGrafanaTemplateRequestObject

	request.Id = id

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetGrafanaTemplate(ctx, request.(GetGrafanaTemplateRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetGrafanaTemplate")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetGrafanaTemplateResponseObject); ok {
		if err := validResponse.VisitGetGrafanaTemplateResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("Unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+yYX2/bNhDAvwpx26NmyV0GFHpbsy4wtnRDnT3FfmClk82CIlny5NUw9N0HkpIdRcKa",
	"oqgTBHmSIt0f3t3v7iIfoNC10QoVOcgP4Iot1jzcXgvnhFb+1lht0JLA8KJEV1hhqHtJe4OQgyMr1Aba",
	"BCqBsgySP1qsIIcf0pOTtPOQdlJtAqK8Y0Yowg1a/1zxGicctAlY/NQIiyXkt167Ez16Xie9jv7wEQsa",
	"Hgo/89pI//b2sAqaK8hXnfkVJKugPHjWriEZHcOfXFV6lBG4srpRJbvUiqyWbLl3hDV7/3Z5w379ewEJ",
	"SFGgciG2GCNcL24ggcZKyGFLZFyeptqgcrqxBc603aSdkku9bJsACQpBXF0u79reoY1Vg/ksm2U/cWm2",
	"/JVX8Pa4EZDDz7P5LIMEDKdtSEm6m6d1LHf4e4PkL77o3Ae1KL0jpOtexutaXiOhdZDfHkB4j58atPu+",
	"GjlIUQuCpGMq5qnijSTI51kyKnibTJvRVeVwaGekuvZMOKN9grzAqyzzl0IrQhVi4cZIUYRo0o8uknsy",
	"KAjrLxLbN0R7PDu3lu8jCkME/vrDS/3ylacYtlmhS5xuDIvcTfbevdYIFo7i464Yn3uhCK3iki3R7tCy",
	"t9bqUBpwTV1zu48cMC4lOwLTJmC0myDm0iIn7NMWz4aO3uhy/1V5eVBR2hj9AIL593BzP2cxytKn4eKb",
	"Cl6jc3zzgJHXCz6kom94yd7HvD9fJGMJGGcK/+25DCJ3B1t6EGUbp5BEwjGuv4XnJ1ynRpwfmafRFHbP",
	"KTyyDU6MqWMqxlPqYrw93umwOXx1AlEXT42od5rY737DPV+eIgmM9yyxD3smQrxf2IznoSY7x1iLK+yF",
	"v0dbsWP4TDMB3z+m5N9/ap15cZ+V8Ke+s1968DF6MPbVuA2n/qtIN5ZXXPH/+3a6iiI3WBvJCR9nUxB+",
	"ptRILu6VZOLb9mUbPK1t0CHGqAOIVdpO0Ok1g6kI1dDbn7rgkpW4Q6lNjYpYlB389pCnqfRyW+0of529",
	"zqBdt/8FAAD///M6kucoEgAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
